
var path = require('path'),
    fs = require('fs'),
    exists = fs.existsSync || path.existsSync;


module.exports = {
    filter: function(str, stamp) {
        stamp = stamp || 'yui-local';

        return str.replace(/@VERSION@/g, stamp);
    },
    stamp: function(o) {
        var root = o.rootPath;

        if (!exists(root)) {
            throw('Root path does not exist');
        }
        
        return function(req, res, next) {
            //Set the filter type for the seed fetch
            var filt = req.query.filter ? req.query.filter : 'min',
                host = req.headers['x-forwarded-from'] || req.headers.host,
                //Stamp the seed config and version
                seedStamp = '\n\n/* Stamping Seed File */\n' + 
                'YUI.applyConfig({\n' + 
                '   comboBase: "http://' + host + '/yui?",\n' + 
                '   base: "http://' + host + '/build/",\n' + 
                '   combine: true,\n' + 
                '   root: "",\n' + 
                '   filter: "' + filt + '"\n' + 
                '});\n' + 
                '\nYUI.version = "yui-local";';
            
            //Reload seed file on each request
            var f = 'yui/yui-min.js';
            switch (filt) {
                case 'raw':
                    f = 'yui/yui.js';
                    break;
                case 'debug':
                    f = 'yui/yui-debug.js';
                    break;
            }

            var seed = fs.readFileSync(path.join(root, f), 'utf8');

            //Concat the file with the stamp
            res.body = seed + seedStamp;
            //Set the content type
            res.contentType('.js');
            //Send to next route
            next();

        }
    }
}
